import { Client } from "@open-rpc/client-js";
export declare type UserName = string;
export declare type Password = string;
export declare type UserRole = string;
export declare type JWTtoken = string;
export declare type UserId = string;
export declare type NodeName = string;
export declare type NodeNetwork = string;
export declare type SyncType = string;
export declare type RpcApi = boolean;
export declare type WsApi = boolean;
export declare type ContainerId = string;
export declare type RemoveNodeData = boolean;
export declare type StringWxzVcTo3 = string;
export declare type ArrayFGWP0Dez = any[];
export declare type NumberYqdpe1HS = number;
/**
 * Return Success
 */
export declare type StringSGZH347X = string;
/**
 * Success, returns info on new user.
 */
export declare type StringKuNVVqJv = string;
export interface ObjectNHLhFIFl {
    status?: StringSGZH347X;
    message?: StringKuNVVqJv;
    [k: string]: any;
}
/**
 * Returns user removed result
 */
export declare type StringKHMWI8OO = string;
export interface ObjectZRmUiMep {
    status?: StringSGZH347X;
    message?: StringKHMWI8OO;
    [k: string]: any;
}
/**
 * Returns: 'Success'
 */
export declare type StringFR9VhzBk = string;
/**
 * Returns: user info and auth token
 */
export declare type StringWTDZtpEb = string;
export interface ObjectOanxQUxa {
    status?: StringFR9VhzBk;
    message?: StringWTDZtpEb;
    [k: string]: any;
}
/**
 * Response success
 */
export declare type StringKW7DOpmn = string;
/**
 * returns users info and all associated params
 */
export declare type StringG5Vc2T7D = string;
export interface ObjectEGqXlYqR {
    status?: StringKW7DOpmn;
    message?: StringG5Vc2T7D;
    [k: string]: any;
}
/**
 * If returns node docker container info
 */
export declare type StringQmGR35SX = string;
export interface ObjectIL7S6IdL {
    status?: StringFR9VhzBk;
    message?: StringQmGR35SX;
    [k: string]: any;
}
/**
 * Returns Success
 */
export declare type StringA1LMV4Zp = string;
/**
 * Returns deletion info
 */
export declare type StringYGoRXuV3 = string;
export interface UnknownRW4RPe8Q {
    status?: StringA1LMV4Zp;
    message?: StringYGoRXuV3;
    [k: string]: any;
}
/**
 * Returns info about docker contianer node is running in.
 */
export declare type StringNY9Xcoeh = string;
export interface Unknown2ORpcQKq {
    status?: StringFR9VhzBk;
    message?: StringNY9Xcoeh;
    [k: string]: any;
}
/**
 * Returns: 'success'
 */
export declare type StringCbmORhHY = string;
/**
 * Returns solidity code in bytecode, warnings and other params
 */
export declare type StringFrQLE1G0 = string;
export interface ObjectIkayGOO9 {
    status?: StringCbmORhHY;
    message?: StringFrQLE1G0;
    [k: string]: any;
}
/**
 * Returns the web3 call data from your node
 */
export declare type StringJcFBdu7C = string;
export interface ObjectJWqpyTMC {
    status?: StringFR9VhzBk;
    message?: StringJcFBdu7C;
    [k: string]: any;
}
export declare type CreateUser = (userName: UserName, password: Password, userRole: UserRole) => Promise<ObjectNHLhFIFl>;
export declare type DeleteUser = (JWTtoken: JWTtoken, userId: UserId) => Promise<ObjectZRmUiMep>;
export declare type Login = (userName: UserName, password: Password) => Promise<ObjectOanxQUxa>;
export declare type GetUser = (JWTtoken: JWTtoken, userName: UserName) => Promise<ObjectEGqXlYqR>;
export declare type AddNode = (JWTtoken: JWTtoken, userName: UserName, nodeName: NodeName, nodeNetwork: NodeNetwork, syncType: SyncType, rpcApi: RpcApi, wsApi: WsApi) => Promise<ObjectIL7S6IdL>;
export declare type RemoveNode = (JWTtoken: JWTtoken, userName: UserName, containerId: ContainerId, nodeName: NodeName, removeNodeData: RemoveNodeData) => Promise<UnknownRW4RPe8Q>;
export declare type GetNodeContainerInfo = (JWTtoken: JWTtoken, containerId: ContainerId) => Promise<Unknown2ORpcQKq>;
export declare type SolCompile = (solVersion: StringWxzVcTo3, solCode: StringWxzVcTo3) => Promise<ObjectIkayGOO9>;
export declare type EthRpcCall = (userName: UserName, nodeName: NodeName, nodeNetwork: NodeNetwork, web3callMethod: StringWxzVcTo3, web3callParams: ArrayFGWP0Dez, rpcId: NumberYqdpe1HS) => Promise<ObjectJWqpyTMC>;
export interface Options {
    transport: {
        type: "websocket" | "http" | "https";
        host: string;
        port: number;
        path?: string;
    };
}
export declare class EnAPIOpenRPCJsonRpcAPI {
    rpc: Client;
    private validator;
    private openrpcDocument;
    constructor(options: Options);
    /**
     * Initiates [[EnAPIOpenRPCJsonRpcAPI.startBatch]] in order to build a batch call.
     *
     * Subsequent calls to [[EnAPIOpenRPCJsonRpcAPI.request]] will be added to the batch.
     * Once [[EnAPIOpenRPCJsonRpcAPI.stopBatch]] is called, the promises for the [[EnAPIOpenRPCJsonRpcAPI.request]]
     * will then be resolved.  If there is already a batch in progress this method is a noop.
     *
     * @example
     * myClient.startBatch();
     * myClient.foo().then(() => console.log("foobar"))
     * myClient.bar().then(() => console.log("foobarbaz"))
     * myClient.stopBatch();
     */
    startBatch(): void;
    /**
     * Initiates [[Client.stopBatch]] in order to finalize and send the batch to the underlying transport.
     *
     * stopBatch will send the [[EnAPIOpenRPCJsonRpcAPI]] calls made since the last [[EnAPIOpenRPCJsonRpcAPI.startBatch]] call. For
     * that reason, [[EnAPIOpenRPCJsonRpcAPI.startBatch]] MUST be called before [[EnAPIOpenRPCJsonRpcAPI.stopBatch]].
     *
     * @example
     * myClient.startBatch();
     * myClient.foo().then(() => console.log("foobar"))
     * myClient.bar().then(() => console.log("foobarbaz"))
     * myClient.stopBatch();
     */
    stopBatch(): void;
    /**
     *
     */
    createUser: CreateUser;
    /**
     *
     */
    deleteUser: DeleteUser;
    /**
     *
     */
    login: Login;
    /**
     *
     */
    getUser: GetUser;
    /**
     *
     */
    addNode: AddNode;
    /**
     *
     */
    removeNode: RemoveNode;
    /**
     *
     */
    getNodeContainerInfo: GetNodeContainerInfo;
    /**
     *
     */
    sol_compile: SolCompile;
    /**
     *
     */
    ethRpcCall: EthRpcCall;
    private request;
}
export default EnAPIOpenRPCJsonRpcAPI;
